SystemOrganization addCategory: #'Rizel-SMark'!
SystemOrganization addCategory: #'Rizel-SMark-Tests'!

SMarkTimer subclass: #RizelTimer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelTimer class methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/23/2012 10:01'!
numberOfCalls
	<primitive: 'primGetMessagesSent' module: ''>
	
	^ self primitiveFailed.! !

!RizelTimer class methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/23/2012 10:02'!
resetNumberOfCalls
	<primitive: 'primResetMessagesSent' module: ''>
	
	^ self primitiveFailed.! !

!RizelTimer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 07:00'!
numberOfCalls
	^ self class numberOfCalls.! !

!RizelTimer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:49'!
reset
	startTime := 0.
	elapsedTime := 0.
	self class resetNumberOfCalls.! !

!RizelTimer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:48'!
start
	startTime := self numberOfCalls.! !

!RizelTimer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:52'!
stop
	| elapsedInThisPeriod current |
	current := self numberOfCalls.
	elapsedInThisPeriod := current - startTime.
	elapsedTime := elapsedTime + elapsedInThisPeriod.! !

CommandLineHandler subclass: #RizelCommandLineHandler
	instanceVariableNames: 'packageMatching smarkSuites reporter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelCommandLineHandler class methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 09:28'!
commandName
	^ 'rizel'! !

!RizelCommandLineHandler class methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 09:12'!
description
	^ 'run benchmarks'! !

!RizelCommandLineHandler methodsFor: 'activation' stamp: 'JuanPabloSandovalAlcocer 11/23/2012 09:44'!
activate
	self activateHelp.
	self loadPackageMatching.
	self loadSuites.
	self loadReporter.
	
	( self hasOption: 'trackFullTrace' ) 
		ifTrue:  [ self exportProfileWithFuel.   ]
		ifFalse: [ self exportExecutionTime. ].
		
	self exitSuccess.! !

!RizelCommandLineHandler methodsFor: 'tools' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 11:46'!
classSuite
	^ SMarkSuite! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 09:34'!
errorNoPackagesMatchingFound
	" "
	self exitFailure: 'No Packages Matching Found'! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/23/2012 09:37'!
executeBenchMarks

	^ smarkSuites collect: [ :suite |	  (self runner execute: (suite new))].! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/23/2012 09:47'!
exportExecutionTime
	|results|
	results := self executeBenchMarks.
	results do:[ :rst | rst  reportOn: (self stdout) using: reporter ].! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/23/2012 10:01'!
exportProfileWithFuel
	|profile|
	profile := RzProfilerSpy profile:[
		self executeBenchMarks.
		] inPackagesMatching: 'packageMatching'.
	
	FLSerializer serialize: profile on: (self stdout).! !

!RizelCommandLineHandler methodsFor: 'load' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 11:42'!
loadBasicRizel
	Gofer new
 		   url: 'http://ss3.gemstone.com/ss/Rizel';
  		   package: 'Rizel-Spy-Profiler';
  		   package: 'Rizel-SMark';
    		load.
! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 10:15'!
loadPackageMatching
	|packageMatchingOption|
	
	packageMatchingOption := self arguments 
			detect: [ :arg|  arg beginsWithEmpty:'--packagesMatching='  caseSensitive: false. ] 
			ifNone: [ self errorNoPackagesMatchingFound. ].
	
	packageMatching := (packageMatchingOption subStrings: '=') second.
	! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 11:47'!
loadReporter
	|suiteNames suiteParam|
	
	suiteParam := self arguments 
			detect: [ :arg|  arg beginsWithEmpty:'--reporter='  caseSensitive: false. ] 
			ifNone: [nil].

	reporter := suiteParam ifNil:[ 
		
		self reporter					
							] ifNotNil: [ (Smalltalk at: ((suiteParam subStrings: '=' ) second asSymbol)) ].! !

!RizelCommandLineHandler methodsFor: 'load' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 11:41'!
loadSMark
	Gofer new
 	 	squeaksource: 'SMark';
		package: 'ConfigurationOfBenchmarking';
   		 load.
	(Smalltalk at: #ConfigurationOfBenchmarking) project lastVersion load.! !

!RizelCommandLineHandler methodsFor: 'load' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 11:40'!
loadSpy
	"loading Spy"
	[Gofer new
 	   	squeaksource: 'Spy'; 
  	  	package: 'Spy';
   		load.
	] on: Exception do:[ :ex| ex resume].
! !

!RizelCommandLineHandler methodsFor: 'actions' stamp: 'JuanPabloSandovalAlcocer 11/23/2012 09:49'!
loadSuites
	|suiteNames suiteParam|
	
	suiteParam := self arguments 
			detect: [ :arg|  arg beginsWithEmpty:'--suites='  caseSensitive: false. ] 
			ifNone: [nil].
	
	smarkSuites := 
		suiteParam ifNil: [
			self classSuite allSubclasses 
				select: [ :cls | packageMatching match: (cls  class package name asString)].						
		] ifNotNil: [ 
			((suiteParam subStrings: '=' ) second subStrings:',') 
			collect:[ :sn | (Smalltalk at: (sn asSymbol)) ]. 
		
		].! !

!RizelCommandLineHandler methodsFor: 'tools' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 11:47'!
reporter
	^ RizelSimpleReporter.! !

!RizelCommandLineHandler methodsFor: 'tools' stamp: 'JuanPabloSandovalAlcocer 11/20/2012 11:47'!
runner
	^ RizelRunner.! !

SMarkSuite subclass: #RzMarkTestScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark-Tests'!

!RzMarkTestScenario methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/23/2012 09:32'!
benchBasic
	""
	|view|
	view := ROMondrianViewBuilder new.
	view nodes: (1 to: 100).
	view verticalLineLayout.! !

SMarkSuite subclass: #RzRoassalScenario
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark-Tests'!

!RzRoassalScenario methodsFor: 'benchmarking' stamp: 'JuanPabloSandovalAlcocer 11/29/2012 16:26'!
benchFixedSize

	| variableNode fixedSizedNode |
	view shape rectangle width: 50; height: 50.
	variableNode := view node: 'Variable size' forIt: [ view nodes: (1 to: 100). view gridLayout ].

	view shape rectangle width: 50; height: 50; fixedSize.
	fixedSizedNode := view node: 'Fixed size' forIt: [ view nodes: (1 to: 100). view gridLayout ].

	self assert: fixedSizedNode resizeStrategy == ROFixedSizedParent instance.
	self assert: variableNode extent >= (50 @ 50).
	self assert: fixedSizedNode extent = (50 @ 50).
	

	window := view open.
! !

!RzRoassalScenario methodsFor: 'benchmarking' stamp: 'JuanPabloSandovalAlcocer 11/29/2012 16:26'!
benchGraph

	"No error should be raised"
	
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
	window := view open.! !

!RzRoassalScenario methodsFor: 'benchmarking' stamp: 'JuanPabloSandovalAlcocer 11/29/2012 16:25'!
setUp
	view := ROMondrianViewBuilder new! !

!RzRoassalScenario methodsFor: 'benchmarking' stamp: 'JuanPabloSandovalAlcocer 11/29/2012 16:25'!
tearDown
	super tearDown.
	window ifNotNil: [window delete. window := nil]! !

SMarkReporter subclass: #RizelCSVReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelCSVReporter methodsFor: 'reporting' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:08'!
report

	runner results keysAndValuesDo: [:key :value |
		self reportAllRuns: value of: key.
	].

	^ self! !

!RizelCSVReporter methodsFor: 'reporting' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:22'!
reportAllRuns: aListOfResults of: benchmark
	
	stream << 'name, nom';cr.
	
	aListOfResults do: [:result |
		result criteria keysAndValuesDo: [:benchName :timer |
			stream << benchName << ', ' << (timer totalTime asString); cr.]]! !

SMarkReporter subclass: #RizelSimpleReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelSimpleReporter methodsFor: 'reporting' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 12:22'!
reportAllRuns: aListOfResults of: benchmark
	aListOfResults do: [:result |
		result criteria keysAndValuesDo: [:benchName :timer |
			stream << benchName << ': ' << (timer totalTime asString, ' nom'); cr.]]! !

SMarkReporter subclass: #RizelXMLReporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelXMLReporter methodsFor: 'reporting' stamp: 'JuanPabloSandovalAlcocer 11/29/2012 12:57'!
report

	runner results keysAndValuesDo: [:key :value |
		self reportAllRuns: value of: key.
	].

	^ self! !

!RizelXMLReporter methodsFor: 'reporting' stamp: 'JuanPabloSandovalAlcocer 11/29/2012 12:58'!
reportAllRuns: aListOfResults of: benchmark
	
	stream << '<report>';cr.
	
	aListOfResults do: [:result |
		result criteria keysAndValuesDo: [:benchName :timer |
			stream <<'<'<< benchName << '>' << (timer totalTime asString) <<'</'<< benchName << '>'; cr.]]
	stream << '</report>';cr.! !

SMarkRunner subclass: #RizelRunner
	instanceVariableNames: 'warmingUp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-SMark'!

!RizelRunner class methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 07:04'!
defaultTimer
	^ RizelTimer! !

!RizelRunner methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:41'!
initialize
	super initialize.
	warmingUp := false.! !

!RizelRunner methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:41'!
performBenchmark: aSelector
	"Based on an email by Eliot from May 16th, 2011.
	 The first time a method is executed it will get into the inline cache.
	 The second time, it is found in the inline cache, which triggers the JIT compiler to produce code.
	 Thus, the third time it should be executed in the steady state."
	warmingUp := true.
		suite runBenchmark: aSelector.
		Smalltalk garbageCollect.
		suite runBenchmark: aSelector.
		Smalltalk garbageCollect.
	warmingUp := false.
	
	^ super performBenchmark: aSelector.! !

!RizelRunner methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 11/13/2012 06:42'!
recordResults: timer for: aSelector
	"Only record the results when we are not in warmup mode."
	warmingUp ifFalse: [
		super recordResults: timer for: aSelector.
	].! !

!RizelRunner methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 11:37'!
reportOn: aStream
	RizelSimpleReporter reportFor: self on: aStream  
	! !

!RizelRunner methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 11/14/2012 11:51'!
reportOn: aStream using: reporterClass
	reporterClass reportFor: self on: aStream  
	! !
